"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = tslib_1.__importDefault(require("path"));
var util_1 = require("./util");
var webpack_merge_1 = tslib_1.__importDefault(require("webpack-merge"));
function mwBuild(context, next) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _a, cwd, devtool, rules, ENV, packageMap, outputPath, publicPath, hash, output, _b, unknownContextCritical, alias, config, webpackConfig;
        return tslib_1.__generator(this, function (_c) {
            context.output = {};
            context.webpackConfig = {};
            next();
            cwd = context.cwd, devtool = context.devtool, rules = context.rules, ENV = context.ENV, packageMap = context.packageMap, outputPath = context.outputPath, publicPath = context.publicPath, hash = context.hash, output = context.output, _b = context.unknownContextCritical, unknownContextCritical = _b === void 0 ? false : _b, alias = context.alias;
            config = tslib_1.__assign({ cache: true, entry: context.entry || packageMap.entry, resolve: tslib_1.__assign({ modules: ['node_modules'], extensions: [
                        '.web.tsx',
                        '.web.ts',
                        '.web.jsx',
                        '.web.js',
                        '.ts',
                        '.tsx',
                        '.js',
                        '.jsx',
                        '.json',
                        '.json5',
                        '.worker.js',
                        '.worker.jsx',
                        '.gql',
                        '.graphql',
                        '.mjs'
                    ], alias: tslib_1.__assign((_a = {}, _a['@babel/runtime'] = path_1.default.dirname(require.resolve('@babel/runtime/package.json')), _a['react'] = path_1.default.dirname(require.resolve('react/package.json')), _a['react-dom'] = path_1.default.dirname(require.resolve('react-dom/package.json')), _a['babel-core'] = path_1.default.dirname(require.resolve('babel-core/package.json')), _a['tslib'] = path_1.default.dirname(require.resolve('tslib/package.json')), _a), alias) }, context.resolve), output: tslib_1.__assign({ filename: hash ? '[name]-[contenthash].js' : '[name].js', chunkFilename: hash ? '[name].chunk-[contenthash].js' : '[name].chunk.js', globalObject: 'this', pathinfo: false, publicPath: context.ASSET_PATH }, output), context: context.context || cwd, externals: context.externals, node: util_1.getNodeVersion(packageMap), devtool: util_1.getBuildSourceMap(devtool, ENV), module: {
                    strictExportPresence: false,
                    noParse: [/moment$/],
                    rules: rules,
                    unknownContextCritical: unknownContextCritical
                }, plugins: context.plugins, mode: 'none', performance: false }, context.webpackConfig);
            webpackConfig = (context.webpackConfig = webpack_merge_1.default(context.webpackConfig, config));
            if (outputPath) {
                webpackConfig.output.path = path_1.default.join(cwd, outputPath);
            }
            if (publicPath) {
                webpackConfig.output.publicPath = publicPath;
            }
            util_1.checkWebpackConfig(webpackConfig);
            return [2];
        });
    });
}
exports.default = mwBuild;
