"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = tslib_1.__importDefault(require("path"));
var webpack_manifest_plugin_1 = tslib_1.__importDefault(require("webpack-manifest-plugin"));
var workbox_webpack_plugin_1 = tslib_1.__importDefault(require("workbox-webpack-plugin"));
var webpack_pwa_manifest_1 = tslib_1.__importDefault(require("webpack-pwa-manifest"));
function mwPWA(context, next) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var plugins, _a, publicPath, packageMap, pwaManifestOptions, _b, enablePWA, publicURL;
        return tslib_1.__generator(this, function (_c) {
            next();
            plugins = context.plugins, _a = context.publicPath, publicPath = _a === void 0 ? '/' : _a, packageMap = context.packageMap, pwaManifestOptions = context.pwaManifestOptions, _b = context.enablePWA, enablePWA = _b === void 0 ? false : _b;
            if (!enablePWA) {
                return [2];
            }
            publicURL = publicPath.slice(0, -1);
            plugins.push(new webpack_manifest_plugin_1.default({
                fileName: 'asset-manifest.json',
                publicPath: publicPath
            }), new workbox_webpack_plugin_1.default.GenerateSW({
                clientsClaim: true,
                exclude: [/\.map$/, /asset-manifest\.json$/],
                importWorkboxFrom: 'cdn',
                navigateFallback: publicURL + '/index.html',
                navigateFallbackBlacklist: [
                    new RegExp('^/_'),
                    new RegExp('/[^/]+\\.[^/]+$')
                ]
            }), new webpack_pwa_manifest_1.default(tslib_1.__assign({ name: packageMap.name, short_name: packageMap.name, description: packageMap.description, background_color: '#ffffff', crossorigin: 'use-credentials', icons: [
                    {
                        src: path_1.default.join(__dirname, '../assets/favicon.ico'),
                        sizes: [32]
                    }
                ] }, pwaManifestOptions)));
            return [2];
        });
    });
}
exports.default = mwPWA;
