"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var fs_1 = tslib_1.__importDefault(require("fs"));
var path_1 = tslib_1.__importDefault(require("path"));
var ts_transform_graphql_tag_1 = require("ts-transform-graphql-tag");
function default_1(context, next) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var cwd, ENV, typescriptConfigPath, options, tsconfigPath, _a, useGQL;
        return tslib_1.__generator(this, function (_b) {
            cwd = context.cwd, ENV = context.ENV;
            typescriptConfigPath = path_1.default.join(__dirname, '../tsconfig.json');
            options = require(typescriptConfigPath);
            tsconfigPath = path_1.default.resolve(cwd, 'tsconfig.json');
            if (fs_1.default.existsSync(tsconfigPath)) {
                options = require(tsconfigPath);
            }
            options.compilerOptions.sourceMap = ENV.isDevelopment;
            options.compilerOptions.module = 'ESNEXT';
            context.typescriptOptions = context.tsOptions = {
                transpileOnly: true,
                experimentalWatchApi: true,
                compilerOptions: options.compilerOptions
            };
            next();
            _a = context.useGQL, useGQL = _a === void 0 ? true : _a;
            context.tsOptions.getCustomTransformers = function () {
                var before = [];
                if (useGQL) {
                    before.push(ts_transform_graphql_tag_1.getTransformer());
                }
                return { before: before };
            };
            return [2];
        });
    });
}
exports.default = default_1;
